using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    public Hashtable Groups
    {
        get
        {
            if (ViewState["Groups"] == null)
            {
                Hashtable res = new Hashtable();
                ViewState["Groups"] = res;
                return res;
            }
            return (Hashtable)ViewState["Groups"];
        }
        set
        {
            ViewState["Groups"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        RadGrid1.DataBound += new EventHandler(RadGrid1_DataBound);
    }

    void RadGrid1_DataBound(object sender, EventArgs e)
    {
        foreach (GridGroupHeaderItem item in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
        {
            if (Groups.ContainsKey(item.DataCell.Text))
            {
                item.Expanded = (bool)Groups[item.DataCell.Text];
            }
        }
    }

    protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {

        DataTable tbl = new DataTable();
        DataColumn col = new DataColumn("ID");
        col.DataType = typeof(int);
        tbl.Columns.Add(col);
        col = new DataColumn("Name");
        col.DataType = typeof(string);
        tbl.Columns.Add(col);
        col = new DataColumn("Group");
        col.DataType = typeof(string);
        tbl.Columns.Add(col);

        int size = 15;
        int maxLen = size.ToString().Length;
        for (int i = 1; i <= size; i++)
        {
            tbl.Rows.Add(new object[] { i, "Name" + i.ToString("D" + maxLen), "Group" + i % 5 });
        }
        RadGrid1.DataSource = tbl;
    }
    protected void RadGrid1_GroupsChanging(object source, GridGroupsChangingEventArgs e)
    {
        Groups.Clear();
        foreach (GridGroupHeaderItem item in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
        {
            Groups[item.DataCell.Text] = item.Expanded;
        }
    }
    protected void RadGrid1_ItemCommand(object source, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.ExpandCollapseCommandName)
        {
            Groups[((GridGroupHeaderItem)e.Item).DataCell.Text] = !e.Item.Expanded;
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        RadGrid1.Rebind();
    }
}
